//
//  xparse.c
//  
//
//  Created by Xavier Nicolay on 11/02/2017.
//
//

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdbool.h>

#include "xparse.h"

#ifdef DMALLOC
#include <dmalloc.h>
#endif

// global variable (dont forget to use it as external one !)
struct xconfig *config;

// private function
void lrtrim ( char **pstring )
{
   
   bool loop = true;
   int  n;
   char c;
   // left side
   while ( loop )
   {
      if ( *pstring[0] == ' ' )
      {
         (*pstring)++;
         // printf ("avance\n");
      }
      else
         loop = false;
   }
   
   n = strlen( *pstring );
   // printf ("longueur : %u\n",n);
   while ( n > 0 )
   {
      c = (*pstring)[n-1];
      // printf ("caractere lu : %c : %u\n", c,c);
      if ( ( c == 10 ) || ( c == ' ' ) || ( c == '\t' ) )
         (*pstring)[n-1] = '\0';
      else
      {
         n=0; // sortie de boucle
      }
      n--;
   }
   
   // printf ("resultat : -%s-\n", *pstring);
}

// change String to int
int xparse_strtoi( const char *str )
{
   int    v = 0;
   int    j=0;
   int    n;
   char   c;
   
   n = strlen( str );
   
   // if ( ( n == 1 ) && ( str[0] == 10 ) ) n=0;
   
   // printf ("chaine bizarre : -- %c -- %d --\n", str[0], str[0] );
   if (( str[0] == '-' ) || ( str[0] == '+' ))
      j=1;
   while ( j < n )
   {
      c = str[j];
      j++;
      if ( ( c < '0' ) || ( c > '9' ) )
         j=n; // caractere illegal ... on sort
      else
         v = v*10 + (c - '0');
   }
   if ( str[0] == '-' )
      v = -v;
   
   // printf ("xstrtod : (%d) %s -> %f\n", n, str, v);
   return v;
}


// void file_ini_parse( char *filename )
void file_ini_parse( char *filename, struct xconfig **config )
{
   FILE *fd = NULL;
   *config = NULL;
   
   fd = fopen( filename , "r" );
   if ( fd )
   {
      char         buf[1024];
      char        *pbuf;
      char         left[1024];
      char         right[1024];
      char        *pch;
      // bool         loop;
      struct xconfig *newElement;
      struct xconfig *lastElement;
      
      // printf("parsing file....\n");
      lastElement = *config;
      
      while (fgets(buf, 1024, fd) != NULL)
      {
         pbuf = buf;
         lrtrim ( &pbuf );
         
         // On ne prends pas en compte les lignes commencant par un # diese
         if ( pbuf[0] == '#' )
            continue;

         pch = strchr( pbuf, '=');
         if ( pch != NULL )
         {
            int l;
	    char *pcomment=NULL;
            char c;

            memset(left, '\0', sizeof(left));
            memset(right, '\0', sizeof(right));
            strncpy( left, pbuf, pch-pbuf );
            
            // supprime les espaces entre le 1er mot et le signe =
            l = strlen( left );
            while ( l > 0 )
            {
               c = left[l-1];
               // printf ("caractere lu : %c : %u\n", c,c);
               if ( ( c == 10 ) || ( c == ' ' ) || ( c == '\t' ) )
                  left[l-1] = '\0';
               else
               {
                  l=0; // sortie de boucle
               }
               l--;
            }
            pch++;
            pcomment = strstr( pch, "//");
            if ( pcomment != NULL )
            {
               // supprime (s'il en existe, les commentaires en fin de ligne
               pcomment[0] = '\0';
            }
            
            // supprime les espaces eventuels avant et apres
            lrtrim ( &pch );
            l = strlen ( pch );
            memcpy( right, pch, l);
            right[l] = 0;
            // printf ("lecture de : '%s' et '%s'\n", left, right);
            newElement = malloc( sizeof ( struct xconfig ) );
            if ( newElement == NULL )
            {
               printf ("Memory Allocation Impossible\n");
               exit( EXIT_FAILURE );
            }
            newElement->argument = malloc( strlen( left ) + 1);
            newElement->value    = malloc( strlen( right ) + 1);
            strcpy( newElement->argument, left);
            strcpy( newElement->value, right);
            newElement->next     = NULL;
            if ( lastElement == NULL )
            {
               *config = newElement;
               lastElement = newElement;
            }
            else
            {
               lastElement->next = newElement;
               lastElement = newElement;
            }

         }
      }
      fclose( fd );
   }
}

void destroy_config( struct xconfig **config )
// void destroy_config()
{
   struct xconfig *ptrConfig, *freeptr;
   
   if ( *config != NULL)
   {
      ptrConfig = *config;
      while ( ptrConfig != NULL )
      {
         free ( ptrConfig->argument );
         free ( ptrConfig->value );
         freeptr = ptrConfig;
         ptrConfig = ptrConfig->next;
         free ( freeptr );
      }
      *config = NULL;
   }
}

void parse_config( struct xconfig *config )
// void parse_config()
{
   struct xconfig *ptrConfig;
   if ( config != NULL )
   {
      ptrConfig = config;
      while ( ptrConfig != NULL )
      {
         printf( "%s : %s\n", ptrConfig->argument, ptrConfig->value );
         ptrConfig = ptrConfig->next;
      }
   }
}

// void parse_config( struct xconfig *config )
char* search_in_config( char *needle, struct xconfig *config )
{
   struct xconfig *ptrConfig;
   char *result = NULL;
   
   // printf ("recherche needle : %s\n", needle);
   
   if ( config != NULL )
   {
      ptrConfig = config;
      while ( ptrConfig != NULL )
      {
         if ( ! strcmp( needle, ptrConfig->argument ) )
         {
            result = ptrConfig->value;
            ptrConfig = NULL; // sort de la boucle
         }
         else
            ptrConfig = ptrConfig->next;
      }
   }
   
   return result;
}

void file_proto_parse( char *filename, struct xproto **AllProto )
// struct xproto* file_proto_parse( char *filename )
{
   FILE *fd = NULL;
   struct xproto *proto = NULL;
   
   fd = fopen( filename , "r" );
   if ( fd )
   {
      char           buf[1024];
      char          *pbuf;
      char           left[1024];
      char           right[1024];
      char          *pch;
      bool           loop;
      struct xproto *newElement;
      struct xproto *lastElement;
      
      // printf("parsing file....\n");
      lastElement = NULL;
      
      while (fgets(buf, 1024, fd) != NULL)
      {
         pbuf = buf;
         lrtrim ( &pbuf );
         
         // On ne prends pas en compte les lignes commencant par un # diese
         if ( pbuf[0] == '#' )
            continue;
         memset(left, '\0', sizeof(left));
         memset(right, '\0', sizeof(right));
         
         pch = pbuf;
         loop = true;
         while ( loop )
         {
            if ( pch[0] == '\0' )
               loop = false;
            else if ( ( pch[0] == ' ' ) || ( pch[0] == '\t' ) )
            {
               loop = false;
               pch[0] = '\0';
               pch++;
            }
            else
               pch++;
         }
         if ( strlen( pbuf ) > 0 )
         {
            strcpy( left, pbuf);
            
            // on se reposition sur le 2nd mot
            pbuf = pch;
            loop = true;
            while ( loop )
            {
               if ( pch[0] == '\0' )
                  loop = false;
               else if ( (pch[0] == ' ' ) || (pch[0] == '\t' ) )
               {
                  if ( pch == pbuf )
                  {
                     pbuf++;
                     pch++;
                  }
                  else
                  {
                     loop = false;
                     pch[0] = '\0';
                  }
               }
               else
                  pch++;
            }

            if ( strlen (pbuf) > 0 )
            {
               strcpy( right, pbuf );
            }

            // printf ("lecture de : '%s' et '%s'\n", left, right);
            
            newElement = malloc( sizeof ( struct xproto ) );
            if ( newElement == NULL )
            {
               printf ("Memory Allocation Impossible\n");
               exit( EXIT_FAILURE );
            }
            newElement->name  = malloc( strlen( left ) + 1);
            strcpy( newElement->name, left);
            newElement->value = xparse_strtoi( right );
            newElement->next     = NULL;
            if ( lastElement == NULL )
            {
               proto = newElement;
               lastElement = newElement;
            }
            else
            {
               lastElement->next = newElement;
               lastElement = newElement;
            }
         } // end if strlen
      } // end while
      fclose( fd );
   } // end if ( fd)
   *AllProto = proto;
} // end func

// Affiche toutes les valeurs de la liste chainee
void parse_proto( struct xproto *proto)
{
   struct xproto *ptrProto;
   if ( proto != NULL )
   {
      ptrProto = proto;
      while ( ptrProto != NULL )
      {
         printf( "%s : %u\n", ptrProto->name, ptrProto->value );
         ptrProto = ptrProto->next;
      }
   }
}

// recherche dans la liste chainee une valeur et retourne un pointeur sur le nom
char* search_in_proto_by_value(unsigned int v, struct xproto *proto)
{
   struct xproto *ptrProto;
   char *result = NULL;
   
   // printf ("recherche needle : %u\n", v);
   
   if ( proto != NULL )
   {
      ptrProto = proto;
      while ( ptrProto != NULL )
      {
         if ( ptrProto->value == v )
         {
            result = ptrProto->name;
            ptrProto = NULL; // sort de la boucle
         }
         else
            ptrProto = ptrProto->next;
      }
   }
   
   return result;
}

void destroy_proto( struct xproto **AllProto )
{
   struct xproto *ptrProto, *freeptr;
   
   if ( *AllProto != NULL)
   {
      ptrProto = *AllProto;
      while ( ptrProto != NULL )
      {
         free ( ptrProto->name );
         freeptr = ptrProto;
         ptrProto = ptrProto->next;
         free ( freeptr );
      }
      *AllProto = NULL;
   }
}



