//
//  main.h
//  
//
//  Created by Xavier Nicolay on 09/12/2015.
//
// {mapx_y @IP} {mapx_y @IP}

#ifndef main_h
#define main_h

// définit la police pour l'affichage des RTT (-glast)
#define FONT_FILE "./Roboto-Regular.ttf"
#define FONT_SIZE 20

// définit l'épaisseur maximale du tracé (-gout)
#define MAX_THICKNESS 10

// liste de toutes les flux a analyser
struct xtuple
{
   char           posIpStr[50];
   unsigned int   occurence;
   double         rtt_moy;
   struct xtuple *next;
};

// liste des liens MPLS
struct xlien
{
   unsigned int mapx1;
   unsigned int mapy1;
   unsigned int mapx2;
   unsigned int mapy2;
   char         IpStr1[50];
   char         IpStr2[50];
   unsigned int typeLien;
   struct xlien  *next;
};

// occurences de tous les graphes
struct occ_lien
{
   unsigned int xdeb;
   unsigned int ydeb;
   unsigned int xfin;
   unsigned int yfin;
   char         paysDeb[10];
   char         paysFin[10];
   unsigned int occurence;
   double       rtt_moy;
   bool         mpls;
   struct occ_lien *next;
};

// quelques définitions de type de liens
#define TL_NORMAL   1
#define TL_FO       2
#define TL_ETHERNET 3
#define TL_WIFI     4
#define TL_xDSL     5
#define TL_MPLS     6
#define TL_UNKNOWN  9

// Définition de couleurs "type HTML"
#define BEIGE           2
#define BLACK           3
#define BLUE            4
#define CHOCOLATE       5
#define CORAL           6
#define CYAN            7
#define DARKGRAY        8
#define DARKKHAKI       9
#define DARKSLATEGRAY  10
#define DIMGRAY        11
#define GAINSBORO      12
#define GREEN          13
#define GOLD           14
#define GRAY           15
#define INDIGO         16
#define KHAKI          17
#define LAVENDER       18
#define LIGHTGREY      19
#define LIGHTSLATEGRAY 20
#define LIME           21
#define LIMEGREEN      22
#define MAGENTA        23
#define MAROON         24
#define NAVY           25
#define ORANGE         26
#define PINK           27
#define RED            28
#define SILVER         29
#define SLATEGRAY      30
#define VIOLET         31
#define WHITE          32
#define YELLOW         33

// Quelques définitions utiles (pour l'écriture de texte "penché")
#define PI 3.141592
#define DEG2RAD(x) ((x)*PI/180.)
#define RAD2DEG(x) ((x)*180/PI)

#endif /* main_h */
